local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff

-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
s.RegisterModuleSpamFunction(AddonName, function() a.RunSpamTable()
	a.Flash("Legacy of the Emperor")
	a.Flash("Spear Hand Strike", "Paralysis", "Leg Sweep as Interrupt") -- interrupt casters
	a.Flash("Fortifying Brew") -- emergency CD for every spec
	a.FlashAll("Tiger's Lust", "Chi Brew", "Charging Ox Wave", "Dampen Harm", "Diffuse Magic") -- Talents
	x.Chi = s.Power("player", SPELL_POWER_CHI )
	x.MaxChi = s.MaxPower("player", SPELL_POWER_CHI)
	x.Energy = s.Power("player", SPELL_POWER_ENERGY )
	x.InCombat = s.InCombat()
	x.Spec = s.TalentMastery()
	x.AoE = a.AoE()
	if x.Spec == 1 then
		-- Brewmaster
		x.ShuffleDuration = s.BuffDuration(115307--[[Shuffle]], "player")
		a.Flash("Stance of the Sturdy Ox")
		a.FlashAll("Clash", "Roll") -- if we are not in range, use these
		a.Flash("Provoke") -- taunt if tanking and not keeping aggro
		a.Flash("Dizzying Haze") -- something to do at range, while kiting or to set up a Breath of Fire
		a.Flash("Keg Smash",
		        "Rushing Jade Wind (Brewmaster)", "Blackout Kick (Brewmaster)",
				"Leg Sweep in AoE",
				"Breath of Fire", "Chi Wave", "Zen Sphere", "Chi Burst", 
				"Expel Harm (Brewmaster)",
				"Spinning Crane Kick (Brewmaster)",
				"Jab (Brewmaster)",
				"Tiger Palm (Brewmaster)")
		a.Flash("Elusive Brew") -- flash Elusive Brew at 3 Stacks
		a.FlashAll("Guard", "Purify Moderate Stagger", "Purify Heavy Stagger") -- emergency buttons for Brewmasters
	elseif x.Spec == 2 then
		-- Mistweaver
		a.Flash("Stance of the Wise Serpent")
	elseif x.Spec == 3 then
		-- Windwalker
		x.EnergyPerSecond = a.energyRegeneration()
		x.TimeToMax = (100 - x.Energy) / x.EnergyPerSecond
		x.FoFCast = 400 / (100 + GetMeleeHaste())
		x.Bloodlust = a.Bloodlust()
		a.Flash("Stance of the Fierce Tiger")
		a.Flash("Legacy of the White Tiger")
		a.Flash("Flying Serpent Kick", "Roll")
		if x.AoE then
			a.Flash("Potion with Bloodlust or TTD <= 60",
			        "Synapse Springs",
					"Berserking",
					"Blood Fury",
					"Rising Sun Kick (Debuff)",
					"Tiger Palm (Buff)",
					"Tigereye Brew",
					"Energizing Brew",
					"Invoke Xuen, the White Tiger",
					"Rushing Jade Wind",
					"Rising Sun Kick at 4+ Chi",
					"Spinning Crane Kick (WW)")
		elseif not s.Channeling(nil, "player") then
			a.Flash("Potion with Bloodlust or TTD <= 60",
			        "Synapse Springs",
					"Berserking",
					"Blood Fury",
					"Rising Sun Kick (Debuff)",
					"Tiger Palm (Buff)",
					"Tigereye Brew",
					"Energizing Brew",
					"Invoke Xuen, the White Tiger",
					"Rushing Jade Wind",
					"Rising Sun Kick",
					"Fists of Fury",
					"Combo Breaker: Blackout Kick",
					"Blackout Kick w/ time to max energy <= 2",
					"Combo Breaker: Tiger Palm",
					"Expel Harm (Windwalker)",
					"Jab (Windwalker)",
					"Blackout Kick at max Chi")
		end
	end
end)
